from config import FTP_CLIENT_ENCODING

###############################################################################
# pak for better webdav encoding support
# also hack to trim windows xp auth hostname, which is hostname\username,
###############################################################################
from ZServer.HTTPServer import zhttp_handler
from base64 import decodestring, encodestring

# "Microsoft .* DAV 1.1" ASCII CP932 UTF-8
# "(Microsoft .* DAV $)" UTF-8 CP932
# "Microsoft .* DAV" UTF-8 CP932
# "(Microsoft .* DAV 1.1)" CP932 UTF-8
# "Microsoft-WebDAV*" UTF-8 CP932
# "RMA/*" CP932
# cadaver/ UTF-8 EUCJP-MS
import re
gb_agent_rex = re.compile('Microsoft .* DAV 1.1|Microsoft .* DAV$|cadaver/|RMA/*')

original_get_environment = zhttp_handler.get_environment

def get_environment(self, request):
    env = original_get_environment(self, request)

    if gb_agent_rex.search(env.get("HTTP_USER_AGENT", "")):
        try:
            unicode(env["PATH_INFO"], 'utf-8')
        except:
            env["PATH_INFO"] = env["PATH_INFO"].decode(FTP_CLIENT_ENCODING).encode('utf-8')
            env["PATH_TRANSLATED"] = env["PATH_TRANSLATED"].decode(FTP_CLIENT_ENCODING).encode('utf-8')

    # trim windows xp auth hostname
    if env.has_key('HTTP_AUTHORIZATION') and env['HTTP_AUTHORIZATION'][:6].lower() == 'basic ':
        [name,password] = decodestring(env['HTTP_AUTHORIZATION'][6:]).split(':')
        env['HTTP_AUTHORIZATION'] = 'Basic %s' % encodestring('%s:%s' % (name.split('\\')[-1], password))
    return env

zhttp_handler.get_environment = get_environment

#############################################################################
# hack zope if you wanto support windows webfolder
#############################################################################
from webdav.Collection import Collection
from webdav.Resource import Resource
from ZServer.HTTPResponse import ZServerHTTPResponse

original_resource_dave__init = Resource.dav__init
def resource_dav__init(self, request, response):
    response.setHeader('MS-Author-Via', 'DAV')
    # see: http://teyc.editthispage.com/2005/06/02
    response.setHeader('Public', ', '.join(self.__http_methods__))
    # response.setHeader('DAV/2', '')
    original_resource_dave__init(self, request, response)

Resource.dav__init = resource_dav__init

original_collection_dave__init = Collection.dav__init
def collection_dav__init(self, request, response):
    response.setHeader('MS-Author-Via', 'DAV')
    # see: http://teyc.editthispage.com/2005/06/02
    response.setHeader('Public', ', '.join(self.__http_methods__))
    # response.setHeader('DAV/2', '')
    original_collection_dave__init(self, request, response)

Collection.dav__init = collection_dav__init

original_response_str = ZServerHTTPResponse.__str__
def response_str(self, html_search=re.compile('<html>',re.I).search):
    self.setHeader('MS-Author-Via', 'DAV')
    # self.setHeader('DAV/2', '')
    return original_response_str(self, html_search)

ZServerHTTPResponse.__str__ = response_str


# Hiding the displayname tag.
pm=({'id':'creationdate',     'mode':'r'},
    {'id':'resourcetype',     'mode':'r'},
    {'id':'getcontenttype',   'mode':'r'},
    {'id':'getcontentlength', 'mode':'r'},
    {'id':'source',           'mode':'r'},
    {'id':'supportedlock',    'mode':'r'},
    {'id':'lockdiscovery',    'mode':'r'},
    )

from OFS.PropertySheets import DAVProperties
DAVProperties.pm = pm


# Replace special characters in URL using the "%xx" escape.
from urllib import quote
def safe_quote_word(url, mark=r'%'):
    if url.find(mark) > -1:
        return url
    return quote(url)

def safe_quote(url, mark=r'%'):
    res=''
    words=url.split('/')
    for word in words:
        if len(word) > 0:
            res=res+'/'+safe_quote_word(word)
    return res

from webdav import davcmds
davcmds.safe_quote = safe_quote
